
import java.util.Iterator;
import java.util.ArrayList;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;

public class GraphView extends Canvas{

	ArrayList dieKnoten;		// das ganze Netz
	Weg aktuellerWeg;			// aktueller Weg muss kenntlich gemacht werden
	Knoten start;				// diese beiden mssen
	Knoten ziel;				// optisch markiert werden

	public GraphView(Iterator alleKnoten, Knoten s, Knoten z, Weg w){
		
		start = s;
		ziel = z;
		aktuellerWeg = w;
		setzeKnoten(alleKnoten);
		
		
	}
	
	
	public void paint(Graphics g){
		Iterator knoten = dieKnoten.iterator();
		// Kanten zeichnen	
		g.setColor(Color.gray);
		while(knoten.hasNext()){
			// Knoten k besorgen
			Knoten k = (Knoten)knoten.next();
			// Nachfolgerliste von k besorgen
			Iterator nachfolger = k.nachfolgerListe();
			
			while(nachfolger.hasNext()){
				// Nachfolger n besorgen
				Knoten n = (Knoten)nachfolger.next();
				// Linie von k nach n zeichnen
				g.drawLine((int)k.x,(int)k.y,(int)n.x,(int)n.y);
			}
		}

		// aktuellen Weg zeichnen
		Iterator aw = aktuellerWeg.wegIterator();
		int x1, y1, x2 = 0, y2 = 0;	// Linienpunkte
		boolean first = true;
		
		g.setColor(Color.red);
		while(aw.hasNext()){
			Knoten k = (Knoten)aw.next();
			
			 x1 = (int)  k.x;
			 y1 = (int)  k.y;
			
			 if(first){
			 	x2 = x1;
				y2 = y1;
				first = false;
			 }
			
			g.drawLine(x1, y1, x2, y2);
				
		 	x2 = x1;
			y2 = y1;
		
		
		}
		g.setColor(Color.black);

		// Knoten zeichnen	
		knoten = dieKnoten.iterator();
		while(knoten.hasNext()){
			// Knoten k besorgen
			Knoten k = (Knoten)knoten.next();
			g.fillOval((int)k.x-8,(int)k.y-8,16,16);			
		}
		// Start und Ziel hervorheben
		g.fillOval((int)start.x-10,(int)start.y-10,20,20);			
		g.fillOval((int)ziel.x-10,(int)ziel.y-10,20,20);			
	
	
		//Knoten labeln
		g.setColor(Color.white);
		knoten = dieKnoten.iterator();
		while(knoten.hasNext()){
			// Knoten k besorgen
			Knoten k = (Knoten)knoten.next();
			g.drawString(k.name,(int)k.x-4,(int)k.y+4);			
			
		}
	}

	// Start und Zielknoten identifizieren
	public void markiereStartZiel(Knoten s, Knoten z){
		start = s;
		ziel = z;
	}
	
	// alle Knoten des Graphs speichern
	public void setzeKnoten(Iterator i){
		dieKnoten = new ArrayList();
		while(i.hasNext()){
			dieKnoten.add(i.next());
		}
	}

	// Iterator fr den aktuellen Weg setzen
	public void setzeWeg(Weg w){
		aktuellerWeg = w;	
	}



}
