import java.util.Iterator;
import java.util.ArrayList;


public class Weg{

	ArrayList wegKnoten;


	public Weg(){
		wegKnoten = new ArrayList();
	}

	public Weg(Knoten startknoten){
		wegKnoten = new ArrayList();
		wegKnoten.add(0, startknoten);
	}

	// liefere Liste von Nachfolgewegen
	public Iterator expandiere(){
		ArrayList ergebnis = new ArrayList();

		// letzen Knoten des Weges besorgen
		Knoten letzter = (Knoten)wegKnoten.get(wegKnoten.size()-1);
		
		// Nachfolgerliste von letzter besorgen
		Iterator nachfolger = letzter.nachfolgerListe();
			while(nachfolger.hasNext()){
				// Nachfolger n besorgen
				Knoten n = (Knoten)nachfolger.next();
				// Zyklencheck:
				if(!wegKnoten.contains(n)){
					// verlngerten Weg in das Ergebnis aufnehmen
					ergebnis.add(verlaengereDichUm(n));
				}
			}

		// expandierte Wege liefern (als Liste)
		return ergebnis.iterator();
	}

	// Um k verlngerte (shallow) Kopie von this liefern
	public Weg verlaengereDichUm(Knoten k){

		Weg w2 = new Weg();
		
		Iterator i = wegKnoten.iterator();
		
		while(i.hasNext()){
			w2.haengeAn((Knoten) i.next());
		}
		w2.haengeAn(k);

		return w2;
	}

	// Knoten hinten an einen Weg anhngen
	public void haengeAn(Knoten k){
		wegKnoten.add(k);
	}

	// Ist dein letzter Knoten der Knoten k?
	public boolean endestDuIn(Knoten k){
		return wegKnoten.get(wegKnoten.size()-1) == k;
	}

	// Iterator ber den Weg liefern
	public Iterator wegIterator(){
		//if(wegKnoten.isEmpty())
		//	return new Weg().wegIterator();
		return wegKnoten.iterator();
	}

	// Weg ausgeben
	public void print(){
		System.out.print("[");
		Iterator i = wegKnoten.iterator();
		while(i.hasNext()){
			Knoten k = (Knoten)(i.next());
			System.out.print(" "+k.name+" ");
		}
		System.out.print("]");
	}
	
	public String toString(){
		StringBuffer buf= new StringBuffer("[");
		Iterator i = wegKnoten.iterator();
		while(i.hasNext()){
			Knoten k = (Knoten)(i.next());
			buf.append(k.name);
			buf.append(", ");
		}
		
		if(buf.length() > 2)
			buf.replace(buf.length()-2, buf.length()-1,"]");
		else buf.append("]");


		return buf.toString();
	}
	
}
